library IEEE;
library CRIS_LIBRARY;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use CRIS_LIBRARY.alupack.all;

-------------------------------------------------------------------------------
entity alu is
  port (
    a, b : in stdbus;
    func : in std_logic_vector(1 downto 0);
    clk, reset : in std_logic;
    flag : out std_logic;
    c : out stdbus);
end alu;

-------------------------------------------------------------------------------
architecture rtl of alu is

  signal intflag : std_logic;
  signal intbus : stdbus;
  
  begin

    regp : process (clk, reset)
    begin
      if (reset = '1') then
        flag <= '0';
        c <= "0000";
      elsif (clk' event and clk = '0') then
        flag <= intflag;
        c <= intbus;
      end if;
    end process regp;

    alup : process(a, b, func)
    begin
      if func(1) = '0' then
        usadd(a, b, intbus, func(0), intflag);
      else
        ussub(a, b, intbus, func(0), intflag);
      end if;
    end process alup;

  end rtl;
-------------------------------------------------------------------------------
